-- BNF Converter: Error Monad
-- Copyright (C) 2004  Author:  Aarne Ranta

-- This file comes with NO WARRANTY and may be used FOR ANY PURPOSE.
module Parser.ErrM where

-- the Error monad: like Maybe type with error msgs

data Err a = Ok a | Bad String
  deriving (Read, Show, Eq)



-- modif
newtype P a = P (String -> Int -> Err a)
runP :: P a -> String -> Int -> Err a
runP (P f) = f

lineP :: P Int
lineP = P $ \_ l -> Ok l



instance Monad Err where
   return      = Ok
   fail        = Bad
   Ok a  >>= f = f a
   Bad s >>= f = Bad s

instance Monad P where
    return m = P $ \_ _ -> Ok m
    m >>= k = P $ \s l -> case runP m s l of
                            Ok a -> runP (k a) s l
                            Bad err -> Bad err
    fail s = P $ \_ _ -> Bad s