-- This Happy file was machine-generated by the BNF converter
{
module Parser.Parglobaltype where
import Common.Absglobaltype
import Parser.Lexglobaltype
import Monad
import Common.Utils
import Parser.ErrM
}

%name pProgram Program

-- no lexer declaration
%monad { P } { thenM } { returnM }
%tokentype { Token }

%token 
 ':' { PT _ (TS ":") }
 '[' { PT _ (TS "[") }
 ']' { PT _ (TS "]") }
 '{' { PT _ (TS "{") }
 '}' { PT _ (TS "}") }
 '|' { PT _ (TS "|") }
 '->' { PT _ (TS "->") }
 '(' { PT _ (TS "(") }
 ')' { PT _ (TS ")") }
 '.' { PT _ (TS ".") }
 '::' { PT _ (TS "::") }
 ',' { PT _ (TS ",") }
 '!' { PT _ (TS "!") }
 ';' { PT _ (TS ";") }
 '((' { PT _ (TS "((") }
 '))' { PT _ (TS "))") }
 '?' { PT _ (TS "?") }
 '$' { PT _ (TS "$") }
 '&' { PT _ (TS "&") }
 '-' { PT _ (TS "-") }
 '==' { PT _ (TS "==") }
 '!=' { PT _ (TS "!=") }
 '>' { PT _ (TS ">") }
 '<' { PT _ (TS "<") }
 '<=' { PT _ (TS "<=") }
 '>=' { PT _ (TS ">=") }
 '=>' { PT _ (TS "=>") }
 '/' { PT _ (TS "/") }
 '*' { PT _ (TS "*") }
 '+' { PT _ (TS "+") }
 '_|_' { PT _ (TS "_|_") }
 '@' { PT _ (TS "@") }
 'Exists' { PT _ (TS "Exists") }
 'False' { PT _ (TS "False") }
 'Forall' { PT _ (TS "Forall") }
 'Global' { PT _ (TS "Global") }
 'Process' { PT _ (TS "Process") }
 'True' { PT _ (TS "True") }
 'and' { PT _ (TS "and") }
 'bool' { PT _ (TS "bool") }
 'date' { PT _ (TS "date") }
 'else' { PT _ (TS "else") }
 'end' { PT _ (TS "end") }
 'if' { PT _ (TS "if") }
 'init' { PT _ (TS "init") }
 'int' { PT _ (TS "int") }
 'join' { PT _ (TS "join") }
 'mu' { PT _ (TS "mu") }
 'not' { PT _ (TS "not") }
 'nu' { PT _ (TS "nu") }
 'or' { PT _ (TS "or") }
 'string' { PT _ (TS "string") }
 'then' { PT _ (TS "then") }

L_integ  { PT _ (TI $$) }
L_quoted { PT _ (TL $$) }
L_ident  { PT _ (TV $$) }
L_err    { _ }


%attributetype { Attrs a }
%attribute result { a } 
%attribute atype { Typ }                  -- synth ($$... = $1...)
%attribute atable { SymbolTable }         -- inh   ($1... = $$...)
%attribute alist  { [(Variable, Typ)] }   -- synth 
%attribute alength { Int }                -- synth
%attribute alisttype { [Typ] }            -- synth


-- %left MYOP
%left 'and' 'or'
%nonassoc '<' '>' '>=' '<=' '=>' '==' '!=' '=>'
%left '+' '-'
%left '*' '/'
%left MYNOT



%%

Integer :: { Attrs [P ()] -> ([P ()], Attrs Integer) } 
Integer : L_integ  { 
  $$ = (read $1) :: Integer ;
  $$.atype = TInt  }

String :: { Attrs [P ()] -> ([P ()], Attrs String) }  
String : L_quoted {
  $$ = $1 ;
  $$.atype = TString }

Ident :: { Attrs [P ()] -> ([P ()], Attrs Ident) }   
Ident : L_ident  { $$ = Ident $1 }

Program :: { Attrs [P ()] -> ([P ()], Attrs Program) }
Program : ListGlobalSpecification {
  $$ = GlobalProg $1;
  $>.atable = newst } 
| 'Process' ':' Process {
  $$ = SingleProg $3 ;
  $3.atable = newst }
| ListGlobalSpecification 'Process' ':' Process {
  $$ = Prog $1 $4 ;
  $1.atable = newst ;
  $4.atable = newst }


GlobalSpecification :: { Attrs [P ()] -> ([P ()], Attrs GlobalSpecification) }
GlobalSpecification : 'Global' '[' Channel ']' ':' DistributedInteraction {
  $$ = Global $3 $6 ;
  $>.atable = $$.atable
} 


ListGlobalSpecification :: { Attrs [P ()] -> ([P ()], Attrs [GlobalSpecification]) }
ListGlobalSpecification : GlobalSpecification ListGlobalSpecification {
  $$ = (:) $1 $2 ;
  $2.atable = $$.atable ;
  $1.atable = $$.atable} 
| GlobalSpecification {
  $$ = (:[]) $1 ;
  $1.atable = $$.atable}


DistributedInteraction :: { Attrs [P ()] -> ([P ()], Attrs DistributedInteraction) }
DistributedInteraction : Interaction {
  $$ = SingleInter $1;
  $>.atable = $$.atable} 
| '{' ListConcurInteraction '}' {
  $$ = ParallelInter $2;
  $>.atable = $$.atable}


ConcurInteraction :: { Attrs [P ()] -> ([P ()], Attrs ConcurInteraction) }
ConcurInteraction : DistributedInteraction {
  $$ = Conc $1;
  $>.atable = $$.atable } 


ListConcurInteraction :: { Attrs [P ()] -> ([P ()], Attrs [ConcurInteraction]) }
ListConcurInteraction : ConcurInteraction '|' ListConcurInteraction {
  $$ = (:) $1 $3 ;
  $1.atable = $$.atable ;
  $>.atable = $$.atable} 
| ConcurInteraction {
  $$ = (:[]) $1 ;
  $>.atable = $$.atable}


Interaction :: { Attrs [P ()] -> ([P ()], Attrs Interaction) }
Interaction : Participant '->' Participant ':' Channel '(' ListVarDecl ')' '[' Assertion ']' '.' DistributedInteraction {
  $$ = ValPass $1 $3 $5 $7 $10 $13 ;
  $10.atable = stinserts $$.atable $7.alist ;
  $>.atable = stinserts $$.atable $7.alist 
  } 
| Participant '->' Participant ':' Channel '(' DelegDecl ')' '[' Assertion ']' '.' DistributedInteraction {
  $$ = Deleg $1 $3 $5 $7 $10 $13;
  $10.atable = $$.atable ;
  $>.atable = $$.atable }
| Participant '->' Participant ':' Channel '::' BranchId '{' ListBranchElmt '}' {
  $$ = LabelPass $1 $3 $5 $7 $9;
  $9.atable = $$.atable }
| 'end' {
  $$ =  End }
| 'mu' Variable '(' ListExp ')' '(' ListVarDeclLoc ')' '[' Assertion ']' '.' DistributedInteraction {
  $$ = Recur $2 $4 $7 $10 $13 ;
  $10.atable = stinserts $$.atable $7.alist ;
  $4.atable = stinserts $$.atable $7.alist ;
  $>.atable = stinserts $$.atable $7.alist ;
  where unless ($4.alength == $7.alength) (fail "number of expressions and number of variables should be the same.");
  where unless ($4.alisttype == (map (\(v,t) -> t) $7.alist)) (fail "type mismatch")
}
| Variable '(' ListExp ')' {
  $$ = RecCall $1 $3 ;
  $3.atable = $$.atable}


BranchElmt :: { Attrs [P ()] -> ([P ()], Attrs BranchElmt) }
BranchElmt : '[' Assertion ']' Label ':' DistributedInteraction {
  $>.atable = $$.atable ;
  $2.atable = $$.atable ;
  $$ = BranchingElmt $2 $4 $6 } 


ListBranchElmt :: { Attrs [P ()] -> ([P ()], Attrs [BranchElmt]) }
ListBranchElmt : BranchElmt ',' ListBranchElmt {
  $>.atable = $$.atable ;
  $1.atable = $$.atable ;
  $$ = (:) $1 $3 } 
| BranchElmt {
  $>.atable = $$.atable ;
  $$ = (:[]) $1 }


Process :: { Attrs [P ()] -> ([P ()], Attrs Process) }
Process : Primitive {
  $$ = SingleProcess $1;
  $1.atable = $$.atable} 
| '{' ListConcurProcess '}' {
  $$ = ParallelProcess $2;
  $2.atable = $$.atable}


ConcurProcess :: { Attrs [P ()] -> ([P ()], Attrs ConcurProcess) }
ConcurProcess : Process {
  $$ = ConcP $1;
  $1.atable = $$.atable} 


ListConcurProcess :: { Attrs [P ()] -> ([P ()], Attrs [ConcurProcess]) }
ListConcurProcess : ConcurProcess '|' ListConcurProcess {
  $3.atable = $$.atable ;
  $1.atable = $$.atable ;
  $$ = (:) $1 $3 } 
| ConcurProcess {
  $1.atable = $$.atable ;
  $$ = (:[]) $1 }


Primitive :: { Attrs [P ()] -> ([P ()], Attrs Primitive) }
Primitive :
'init' ':' Channel '[' ListParticipant ']' '(' ListChannel ')' '.' Process {
  $$ = PInit $3 $5 $8 $11 ;
  $>.atable = $$.atable;
  where unless ($5.alength > 1) (fail "session initialisation should be done with at least two participants.")} 

| 'join' ':' Channel '[' Participant ']' '(' ListChannel ')' '.' Process {
  $>.atable = $$.atable;
  $$ = PJoin $3 $5 $8 $11 }

| Channel '!' '(' ListExp ')' '(' ListVarDecl ')' '[' Assertion ']' ';' Process {
  $10.atable = stinserts $$.atable $7.alist ;
  $>.atable = stinserts $$.atable $7.alist ;
  $4.atable = stinserts $$.atable $7.alist ;
  $$ = PSend $1 $4 $7 $10 $13 ;
  where unless ($4.alength == $7.alength) (fail "number of expressions and number of variables should be the same.") ;
  where unless ($4.alisttype == (map (\(v,t) -> t) $7.alist)) (fail "type mismatch")
    }

| Channel '!' '((' ListChannel '))' '(' DelegDecl ')' '[' Assertion ']' ';' Process {
  $10.atable = $$.atable;
  $$ = PDelegS $1 $4 $7 $10 $13;
  $>.atable = $$.atable;
  where unless ($4.alength == $7.alength) (fail "The number of channels sent for delegation is not the same as in the end-point type.")}

| Channel '?' '(' ListVarDecl ')' '[' Assertion ']' ';' Process {
  $7.atable = stinserts $$.atable $4.alist ;
  $$ = PReceive $1 $4 $7 $10;
  $10.atable = stinserts $$.atable $4.alist ;
}

| Channel '?' '((' DelegDecl '))' '[' Assertion ']' ';' Process {
  $7.atable = $$.atable;
  $$ = PDelegR $1 $4 $7 $10;
  $>.atable = $$.atable }

| Channel '$' '[' Assertion ']' BranchId '.' Label ';' Process {
  $4.atable = $$.atable;
  $$ = PSelect $1 $4 $6 $8 $10; 
  $>.atable = $$.atable}

| Channel '&' BranchId '{' ListPBranchElmt '}' {
  $$ = PBranch $1 $3 $5;
  $5.atable = $$.atable }

| 'end' {$$ =  PEnd }

| 'if' Exp 'then' Process 'else' Process {
  $2.atable = $$.atable ;
  $4.atable = $$.atable ;
  $6.atable = $$.atable ;
  where unless ($2.atype == TBool) (fail "condition in a if-then-else should be boolean.");
  $$ = ITE $2 $4 $6 ;
}

| '(' 'nu' Channel ')' Process {
  $$ = Hiding $3 $5;
  $5.atable = $$.atable }

| 'mu' Variable '(' ListExp ';' ListChannel ')' '(' ListVarDecl ';' ListChannel ')' '.' Process {
  $$ = PRecur $2 $4 $6 $9 $11 $14 ;
  $4.atable = stinserts $$.atable $9.alist;
  $>.atable = stinserts $$.atable $9.alist;
  where unless ($4.alength == $9.alength) (fail "number of expressions and number of variables should be the same.");
  where unless ($6.alength == $11.alength) (fail "number of channels should be the same.");
  where unless ($4.alisttype == (map (\(v,t) -> t) $9.alist)) (fail "type mismatch") ;
  }

| 'mu' Variable '(' ListExp ')' '(' ListVarDecl ')' '.' Process {
  $$ = PRecur $2 $4 [] $7 [] $10 ;
  $4.atable = stinserts $$.atable $7.alist;
  $>.atable = stinserts $$.atable $7.alist;
  where unless ($4.alength == $7.alength) (fail "number of expressions and number of variables should be the same.");
  where unless ($4.alisttype == (map (\(v,t) -> t) $7.alist)) (fail "type mismatch") ;
}

| Variable '(' ListExp ';' ListChannel ')' {
$$ =  PRecCall $1 $3 $5 ;
$3.atable = $$.atable
}

| Variable '(' ListExp ')' {
$$ =  PRecCall $1 $3 [] ;
$3.atable = $$.atable
}


PBranchElmt :: { Attrs [P ()] -> ([P ()], Attrs PBranchElmt) }
PBranchElmt : '[' Assertion ']' Label ':' Process {
  $>.atable = $$.atable ;
  $2.atable = $$.atable ;
  $$ = PBranchElmt $2 $4 $6
} 


ListPBranchElmt :: { Attrs [P ()] -> ([P ()], Attrs [PBranchElmt]) }
ListPBranchElmt : PBranchElmt ',' ListPBranchElmt {
  $$ = (:) $1 $3; 
  $1.atable = $$.atable ;
  $>.atable = $$.atable} 
| PBranchElmt {
  $$ = (:[]) $1;
  $>.atable = $$.atable }


Assertion :: { Attrs [P ()] -> ([P ()], Attrs Assertion) }
Assertion : Exp {
  $$ = Assert $1;
  $>.atable = $$.atable ;
  where unless ($1.atype == TBool) (fail "Assertions must be of type boolean") } 
| '-' { $$ = Assert BTrue}


Exp :: { Attrs [P ()] -> ([P ()], Attrs Exp) }
Exp : Integer { 
  $$ = ExpI $1;
  $$.atype = TInt } 
| Variable {
  $$ =  ExpV $1;
  $$.atype = let {t = stlookup $$.atable $1 } in case t of {
    Nothing -> error $ "Variable not found: " ++ (show $1) ++ ".";
    Just ty -> ty
      }
  }
| String {
  $$ =  ExpS $1;
  $$.atype = TString }
| Integer ':' Integer ':' Integer {
  $$ =  ExpD $1 $3 $5;
  $$.atype = TDate }
| 'True' { $$ = BTrue ;
  $$.atype = TBool }
| 'False' {$$ =  BFalse ;
  $$.atype = TBool }
| 'not' Exp %prec MYNOT {
  $$ = BNot $2;
  $$.atype = TBool ;
  $>.atable = $$.atable ;
  where unless ($2.atype == TBool) (fail "type error in NOT")}
| Exp BinOp Exp %prec 'and' {
  $$ = EBin $1 $2 $3 ; 
  $$.atype = $2.atype ;
  $>.atable = $$.atable ;
  $1.atable = $$.atable ;
  where unless ($1.atype == $3.atype) (fail $ "Bad expression in:\n"++(show $$))}
| Exp ArOp Exp %prec '+'{
 $$ = EAr $1 $2 $3 ; 
 $$.atype = $2.atype ;
 $>.atable = $$.atable ;
 $1.atable = $$.atable ;
 where unless ($1.atype == $3.atype)  (fail $ "Bad arithmetic expression in:\n"++(show $$))}
| 'Exists' ListVarDecl '(' Exp ')' {
  $$ =  EExist $2 $4;
  $$.atype = TBool ;
  $4.atable = stinserts $$.atable $2.alist ;
  where unless (($4.atype == TBool) && ($2.alength > 0)) (fail "problem in Exist")}
| 'Forall' ListVarDecl '(' Exp ')' {
  $$ =  EForall $2 $4;
  $$.atype = TBool;
  $4.atable = stinserts $$.atable $2.alist ;
  where unless (($4.atype == TBool) && ( $2.alength > 0)) (fail "problem in Forall")}
| '(' Exp ')' {$$ =  $2 ; $$.atype = $2.atype; $2.atable = $$.atable; }

ListExp :: { Attrs [P ()] -> ([P ()], Attrs [Exp]) }
ListExp : Exp ',' ListExp {
  $$ = (:) $1 $3 ;
  $>.atable = $$.atable ;
  $1.atable = $$.atable ;
  $$.alength = $3.alength + 1;
  $$.alisttype = (:) $1.atype $3.alisttype } 
| Exp {
  $>.atable = $$.atable ;
  $$ = (:[]) $1 ;
  $$.alength = 1;
  $$.alisttype = (:[]) $1.atype ;
  $$.atype = $1.atype }


BinOp :: { Attrs [P ()] -> ([P ()], Attrs BinOp) }
BinOp : 'or' {
  $$ = EOr ;
  $$.atype = TBool } 
| 'and' {
  $$ =  EAnd;
  $$.atype = TBool }
| '==' {
  $$ =  EEq ;
  $$.atype = TBool}
| '!=' {
  $$ =  ENEq;
  $$.atype = TBool }
| '>' {
  $$ = EGt;
  $$.atype = TBool }
| '<' {
  $$ = ELt;
  $$.atype = TBool }
| '<=' {
  $$ = ELte;
  $$.atype = TBool }
| '>=' {
  $$ =  EGte;
  $$.atype = TBool }
| '=>' {
  $$ =  EImpl;
  $$.atype = TBool }

ArOp :: { Attrs [P ()] -> ([P ()], Attrs ArOp) }
ArOp : '+' {
  $$ = EPlus ;
  $$.atype = TInt } 
| '-' {
  $$ =  EMinus;
  $$.atype = TInt }
| '*' {
  $$ =  EMul ;
  $$.atype = TInt}
| '/' {
  $$ =  EDiv;
  $$.atype = TInt }


-- ArOp :: { Attrs [P ()] -> ([P ()], Attrs ArOp) }
-- ArOp : '+' {
--   $$ = EPlus ;
--   $$.atype = TInt } 
-- | '-' {
--   $$ =  EMinus;
--   $$.atype = TInt }
-- | '*' {
--   $$ =  EMul ;
--   $$.atype = TInt}
-- | '/' {
--   $$ =  EDiv;
--  $$.atype = TInt }


LocalType :: { Attrs [P ()] -> ([P ()], Attrs LocalType) }
LocalType : Channel '!' '<' ListVarDecl '>' '[' Assertion ']' ';' LocalType { $$ = Send $1 $4 $7 $10 } 
  | Channel '!' '<' DelegDecl '>' '[' Assertion ']' ';' LocalType { $$ = LDelegS $1 $4 $7 $10 }
  | Channel '?' '<' ListVarDecl '>' '[' Assertion ']' ';' LocalType { $$ = Receive $1 $4 $7 $10 }
  | Channel '?' '<' DelegDecl '>' '[' Assertion ']' ';' LocalType {$$ =  LDelegR $1 $4 $7 $10 }
  | Channel '&' BranchId '{' ListLabelElmt '}' {$$ =  Branch $1 $3 $5 }
  | Channel '$' BranchId '{' ListLabelElmt '}' { $$ = Select $1 $3 $5 }
  | 'mu' Variable '(' ListExp ')' '(' ListVarDecl ')' '[' Assertion ']' '.' LocalType {$$ =  LRecur $2 $4 $7 $10 $13 }
  | Variable '(' ListExp ')' {$$ =  LRecCall $1 $3 }
  | 'end' {$$ =  LEnd }
  | '_|_' {$$ =  Bottom }


LabelElmt :: { Attrs [P ()] -> ([P ()], Attrs LabelElmt) }
LabelElmt : '[' Assertion ']' Label ':' LocalType { $$ = LabelElmt $2 $4 $6 } 


ListLabelElmt :: { Attrs [P ()] -> ([P ()], Attrs [LabelElmt]) }
ListLabelElmt : LabelElmt ',' ListLabelElmt { $$ = (:) $1 $3 } 
  | LabelElmt {$$ =  (:[]) $1 }


DelegDecl :: { Attrs [P ()] -> ([P ()], Attrs DelegDecl) }
DelegDecl : '[' ListChannel ']' ':' LocalType '@' Participant {
  $$ =  SessPass $2 $5 $7;
  $$.alength = $2.alength} 


Typ :: { Attrs [P ()] -> ([P ()], Attrs Typ) }
Typ : 'int' { $$ = TInt } 
  | 'bool' {$$ =  TBool }
  | 'string' { $$ = TString }
  | 'date' { $$ = TDate }


Participant :: { Attrs [P ()] -> ([P ()], Attrs Participant) }
Participant : Ident { $$ = Parti $1 } 


ListParticipant :: { Attrs [P ()] -> ([P ()], Attrs [Participant]) }
ListParticipant : Participant ',' ListParticipant {
  $$ = (:) $1 $3 ;
  $$.alength = $3.alength + 1} 
| Participant { $$ = (:[]) $1;
  $$.alength = 1}


Channel :: { Attrs [P ()] -> ([P ()], Attrs Channel) }
Channel : Ident { $$ = Chan $1 } 


ListChannel :: { Attrs [P ()] -> ([P ()], Attrs [Channel]) }
ListChannel : Channel ',' ListChannel { $$ = (:) $1 $3 ;
  $$.alength = $3.alength + 1} 
| Channel { $$ = (:[]) $1 ;
  $$.alength = 1}


LLChannel :: { Attrs [P ()] -> ([P ()], Attrs [[Channel]]) }
LLChannel : ListChannel ';' LLChannel { $$ = (:) $1 $3 ;
  $$.alength = $3.alength + 1} 
| ListChannel {$$ =  (:[]) $1;
  $$.alength = 1 }


Label :: { Attrs [P ()] -> ([P ()], Attrs Label) }
Label : Ident {$$ =  Lab $1 } 


BranchId :: { Attrs [P ()] -> ([P ()], Attrs BranchId) }
BranchId : Ident {$$ =  BId $1 } 


Variable :: { Attrs [P ()] -> ([P ()], Attrs Variable) }
Variable : Ident {$$ =  Var $1 } 


ListVariable :: { Attrs [P ()] -> ([P ()], Attrs [Variable]) }
ListVariable : Variable ',' ListVariable {
  $$ = (:) $1 $3 ;
  $$.alength = $3.alength + 1} 
| Variable { $$ = (:[]) $1 ;
  $$.alength = 1}


VarDecl :: { Attrs [P ()] -> ([P ()], Attrs VarDecl) }
VarDecl : Variable ':' Typ {
  $$ = VarDeclaration $1 $3 ;
  $$.alist = [($1,$3)] } 


ListVarDecl :: { Attrs [P ()] -> ([P ()], Attrs [VarDecl]) }
ListVarDecl : VarDecl ',' ListVarDecl { $$ = (:) $1 $3 ;
  $$.alength = $3.alength + 1;
  $$.alist = (++) $1.alist $3.alist} 
| VarDecl { $$ = (:[]) $1 ;
  $$.alength = 1;
  $$.alist = $1.alist
 }


VarDeclLoc :: { Attrs [P ()] -> ([P ()], Attrs VarDeclLoc) }
VarDeclLoc : VarDecl '@' Location { 
  $$ = VarDeclLoc $1 $3;
  $$.alist = $1.alist } 



ListVarDeclLoc :: { Attrs [P ()] -> ([P ()], Attrs [VarDeclLoc]) }
ListVarDeclLoc : VarDeclLoc ',' ListVarDeclLoc { $$ = (:) $1 $3 ;
  $$.alength = $3.alength + 1;
  $$.alist = (++) $1.alist $3.alist } 
 | VarDeclLoc { $$ = (:[]) $1;
  $$.alength = 1;
  $$.alist = $1.alist }


Location :: { Attrs [P ()] -> ([P ()], Attrs Location) }
Location : '{' Participant ',' Participant '}' {$$ =  Loc $2 $4 } 

				       
{

-- returnM :: a -> Err a
-- returnM = return

-- thenM :: Err a -> (a -> Err b) -> Err b
-- thenM = (>>=)

returnM :: a -> P a
returnM = return

thenM :: P a -> (a -> P b) -> P b
thenM = (>>=)



happyError2 :: [Token] -> Err a
happyError2 ts = Bad $ "syntax error at " ++ tokenPos ts ++ if null ts then [] else (" before " ++ unwords (map prToken (take 4 ts)))

happyError :: [Token] -> P a
-- happyError ts = lineP `thenM` \line -> fail (show line ++": parse error!")
happyError ts = lineP `thenM` \line -> fail ("syntax error at: "++ tokenPos ts ++ if null ts then [] else (" before " ++ unwords (map prToken (take 4 ts))))



myLexer = tokens

}

