import Prelude hiding ( catch )
import Language.Haskell.Interpreter
import Control.Monad.CatchIO ( catch )
import Control.Exception.Extensible hiding ( catch )
import Data.Integer.Presburger
import Data.Integer.Presburger.HOAS




main :: IO ()
main = do c <- hinteval "FALSE"
          putStrLn $ show (check c)
          c' <- hinteval "TRUE"
          putStrLn $ show (check c')
          putStrLn "Done."


hinteval :: String -> IO Formula
hinteval s = do c <- runInterpreter (tt s)
                case c of
                  Left err -> error $ printInterpreterError err
                  Right ii -> return ii
                              

tt :: String -> Interpreter Formula
tt s = do loadModules ["Data.Integer.Presburger", "Data.Integer.Presburger.HOAS"]
          setImportsQ [("Prelude", Nothing),
                       ("Data.Integer.Presburger", Nothing),
                       ("Data.Integer.Presburger.HOAS", Nothing)]
          c <- interpret s (as :: Data.Integer.Presburger.Formula)
          return c
        
printInterpreterError :: InterpreterError -> String
printInterpreterError e = "[haskell-hint]\n Ups... " ++ (show e)